#include "include/globe_es.h"
#include <QPainter>
#include <QPaintEngine>
#include <math.h>
//#include <QtGui>
#include <QWidget>
#include "include/mainwindow.h"


GlobeWidget::GlobeWidget(QWidget *parent)
    : QGLWidget(parent)
{

    frames = 0;
    this->setAttribute(Qt::WA_PaintOnScreen);
    this->setAttribute(Qt::WA_NoSystemBackground);
    this->setAutoBufferSwap(false);

#ifdef Q_WS_MAEMO_5
    this->setMinimumSize(360, 360);
#endif

    this->m_fRadius = 1;
    this->m_nSlices = 48;
    this->m_nStacks = 48;
    this->rotate = true;

    QSizePolicy policy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    policy.setHeightForWidth(true);
    this->setSizePolicy(policy);

    this->texture = QImage(":/res/res/earth.png");


    this->m_framerate = true;

}

int GlobeWidget::CalculateFPS(int count)
{
    QTime m_time;
  m_time.start();
   QString str;

 // this->initializeGL();
  // this->paintGL();
  //_globe->paintGL();
//  int count  = 1000;
   this->setRotationY(1);
  for(int i=1;i<=count;i++)
      {
      //glwidget->setWindowTitle(trUtf8("Тестирование 3d интерфейса:")+str.sprintf("Frames: %d",i));
          //glwidget->rotate(0,1);
      this->setRotationX(1);

    // m_globe->repaint();
   //  m_globe->paintGL();
     this->setFramerate(true);
      this->updateGL();

    //this->repaint();
     // this->paintGL();
         }
return m_time.elapsed();
}
 /* void GlobeWidget::SetOpenGL_ES(QString ResTest)
     {
         this->ResTest=ResTest;
     }
*/

void GlobeWidget::SetResTest(QString ResTest)
{
    this->ResTest=ResTest;
}

QString GlobeWidget::GetResTest()
{
    return this->ResTest;
}

GlobeWidget::~GlobeWidget()
{
}



int GlobeWidget::heightForWidth(int width) const
{
    return width;
}

QSize GlobeWidget::sizeHint() const
{
    int width = this->width();
    return QSize(width, this->heightForWidth(width));
}



void GlobeWidget::setRotationX(int angle)
{
    if(angle < 5 && angle > -5)
        this->rotate = true;
    else
        this->rotate = false;

    if(angle > 5 || angle < -5)
        this->m_fAngle_x = angle;
}

void GlobeWidget::setRotationY(int angle)
{
    this->m_fAngle_y = angle;
}

void GlobeWidget::setScaling(int scale)
{

    if (scale > 0)
        this->m_fScale = 1 + qreal(scale) / 50 * 1.0;
    else if (scale < 0)
        this->m_fScale =  1 + (qreal(scale) / 50 * 0.9);
    else
        this->m_fScale = 1;
}

void GlobeWidget::paintEvent(QPaintEvent * /* event */)
{
    QPainter painter;
}

void GlobeWidget::setOutline(bool outline)
{

}

void GlobeWidget::setFramerate(bool framerate)
{
    this->m_framerate = framerate;
}

void GlobeWidget::setSphereVertex(qreal fRadius, int nSlices /*= 48*/, int nStacks /*= 48*/)
{
    // Bind a named texture to a texturing target
    glBindTexture(GL_TEXTURE_2D, m_uiTexture);

    // Calculate only if sphere radius, slices and stack have changes.
    // This will improve the frame rate
    if(this->m_fRadius != this->t_fRadius ||
       this->m_nSlices != this->t_nSlices ||
       this->m_nStacks != this->t_nStacks)
    {
        this->vertices.clear();
        this->normals.clear();
        this->texCoord.clear();

        this->t_fRadius = this->m_fRadius;
        this->t_nSlices = this->m_nSlices;
        this->t_nStacks = this->m_nStacks;

        qreal dLatStart = -90;
        qreal dLonStart = 0.0;
        qreal dLatIncr  = 180.0 / nStacks;
        qreal dLonIncr  = 360.0 / nSlices;

        QVector3D U, V, W, N;
        qreal  dPhi1, dPhi2, pTheta1, pTheta2;

        for(int nCol = 0; nCol < nStacks; nCol++)
        {
            dPhi1 = DEG2RAD((dLonStart + nCol * dLonIncr));
            dPhi2 = DEG2RAD((dLonStart + (nCol + 1) * dLonIncr));

            for(int nRow = 0; nRow < nSlices; nRow++)
            {
                pTheta1 = DEG2RAD((dLatStart + nRow * dLatIncr));
                pTheta2 = DEG2RAD((dLatStart + (nRow + 1) * dLatIncr));

                U.setX( (qreal)(fRadius * cos(dPhi1) * cos(pTheta1)) );
                U.setY( (qreal)(fRadius * sin(pTheta1)) );
                U.setZ( (qreal)(fRadius * sin(dPhi1) * cos(pTheta1)) );

                V.setX( (qreal)(fRadius * cos(dPhi1) * cos(pTheta2)) );
                V.setY( (qreal)(fRadius * sin(pTheta2)) );
                V.setZ( (qreal)(fRadius * sin(dPhi1) * cos(pTheta2)) );

                W.setX( (qreal)(fRadius * cos(dPhi2) * cos(pTheta2)) );
                W.setY( (qreal)(fRadius * sin(pTheta2)) );
                W.setZ( (qreal)(fRadius * sin(dPhi2) * cos(pTheta2)) );

                N = QVector3D::normal // P2 - P1 , P3 - P1
                        (QVector3D(V.x() - U.x(), V.y() - U.y(), V.z() - U.z()),
                         QVector3D(W.x() - U.x(), W.y() - U.y(), W.z() - U.z()));

                this->vertices.append(U);
                this->normals.append(N);
                this->texCoord.append( QVector2D( (180.0 - RAD2DEG(dPhi1))/360.0,
                                                                RAD2DEG((pTheta1 + M_PI_2))/180.0 ) );

                this->vertices.append(V);
                this->normals.append(N);
                this->texCoord.append( QVector2D( (180.0 - RAD2DEG(dPhi1))/360.0,
                                                                RAD2DEG((pTheta2 + M_PI_2))/180.0 ) );

                this->vertices.append(W);
                this->normals.append(N);
                this->texCoord.append( QVector2D( (180.0 - RAD2DEG(dPhi2))/360.0,
                                                                RAD2DEG((pTheta2 + M_PI_2))/180.0 ) );

                V.setX( (qreal)(fRadius * cos(dPhi2) * cos(pTheta1)) );
                V.setY( (qreal)(fRadius * sin(pTheta1)) );
                V.setZ( (qreal)(fRadius * sin(dPhi2) * cos(pTheta1)) );

                N = QVector3D::normal // P3 - P1 , P2 - P1
                                (QVector3D(W.x() - U.x(), W.y() - U.y(), W.z() - U.z()),
                                 QVector3D(V.x() - U.x(), V.y() - U.y(), V.z() - U.z()));

                this->vertices.append(U);
                this->normals.append(N);
                this->texCoord.append( QVector2D( (180.0 - RAD2DEG(dPhi1))/360.0,
                                                                RAD2DEG((pTheta1 + M_PI_2))/180.0 ) );

                this->vertices.append(W);
                this->normals.append(N);
                this->texCoord.append( QVector2D( (180.0 - RAD2DEG(dPhi2))/360.0,
                                                                RAD2DEG((pTheta2 + M_PI_2))/180.0 ) );

                this->vertices.append(V);
                this->normals.append(N);
                this->texCoord.append( QVector2D( (180.0 - RAD2DEG(dPhi2))/360.0,
                                                                RAD2DEG((pTheta1 + M_PI_2))/180.0 ) );
            }
        }
    }

    this->program.setAttributeArray(this->vertexAttr, this->vertices.constData());
    this->program.setAttributeArray(this->texCoordAttr, this->texCoord.constData());
    this->program.setAttributeArray(this->normalAttr, this->normals.constData());

    this->program.setUniformValue(this->textureUniform, 0);    // use texture unit 0

    this->program.enableAttributeArray(this->vertexAttr);
    this->program.enableAttributeArray(this->texCoordAttr);
    this->program.enableAttributeArray(this->normalAttr);

    // Render primitives from array data
    glDrawArrays(GL_TRIANGLES, 0, this->vertices.size());

    this->program.disableAttributeArray(this->vertexAttr);
    this->program.disableAttributeArray(this->texCoordAttr);
    this->program.disableAttributeArray(this->normalAttr);
}

void GlobeWidget::initializeGL()
{
    // Specify the red, green, blue, and alpha values
    // used when the color buffers are cleared. The
    // initial values are all 0.
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);

    // Generate texture names. glGenTextures returns n texture names in textures.
    // The generated textures have no dimensionality; they assume the
    // dimensionality of the texture target to which they are
    // first bound (see glBindTexture).
    glGenTextures(1, &m_uiTexture);
    this->m_uiTexture = bindTexture(this->texture);

    // The QGLShader class allows OpenGL shaders to be compiled.
    // It supports shaders written in the OpenGL Shading Language (GLSL)
    // and in the OpenGL/ES Shading Language (GLSL/ES).
    // QGLShader and QGLShaderProgram shelter the programmer from the details
    // of compiling and linking vertex and fragment shaders.
    QGLShader *vshader = new QGLShader(QGLShader::Vertex);
    const char *vsrc =
        "attribute highp vec4 vertex;\n"
        "attribute highp vec4 texCoord;\n"
        "attribute mediump vec3 normal;\n"
        "uniform mediump mat4 matrix;\n"
        "varying highp vec4 texc;\n"
        "varying mediump float angle;\n"
        "void main(void)\n"
        "{\n"
        "    vec3 toLight = normalize(vec3(0.0, 0.3, 1.0));\n"
        "    angle = max(dot(normal, toLight), 0.0);\n"
        "    gl_Position = matrix * vertex;\n"
        "    texc = texCoord;\n"
        "}\n";
    vshader->compileSourceCode(vsrc);

    QGLShader *fshader = new QGLShader(QGLShader::Fragment);
    const char *fsrc =
        "varying highp vec4 texc;\n"
        "uniform sampler2D tex;\n"
        "varying mediump float angle;\n"
        "void main(void)\n"
        "{\n"
        "    highp vec3 color = texture2D(tex, texc.st).rgb;\n"
        "    color = color * 0.2 + color * 0.8;\n // * angle;\n"
        "    gl_FragColor = vec4(clamp(color, 0.0, 1.0), 1.0);\n"
        "}\n";
    fshader->compileSourceCode(fsrc);

    this->program.addShader(vshader);
    this->program.addShader(fshader);
    this->program.link();

    // Returns the location of the attribute name within this shader
    // program's parameter list. Returns -1 if name is not a valid
    // attribute for this shader program.
    this->vertexAttr = program.attributeLocation("vertex");
    this->normalAttr = program.attributeLocation("normal");
    this->texCoordAttr = program.attributeLocation("texCoord");
    this->matrixUniform = program.uniformLocation("matrix");
    this->textureUniform = program.uniformLocation("tex");

    // Specifies the target texture, which must be either GL_TEXTURE_1D,
    // GL_TEXTURE_2D, or GL_TEXTURE_3D.
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    this->m_fAngle_x = 0;
    this->m_fAngle_y = 0;
    this->m_fScale = 1;
}

void GlobeWidget::paintGL()
{
    QPainter painter;
    painter.begin(this);

    // Flushes the painting pipeline and prepares for the user issuing
    // commands directly to the underlying graphics context. Must be
    // followed by a call to endNativePainting().
    painter.beginNativePainting();

    // Specify the red, green, blue, and alpha values
    // used when the color buffers are cleared. The
    // initial values are all 0.
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    // Clear buffers to preset values
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    // Specifies the target texture, which must be either GL_TEXTURE_1D,
    // GL_TEXTURE_2D, or GL_TEXTURE_3D.
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

    // Define front- and back-facing polygons
    // Specifies the orientation of front-facing polygons.
    // GL_CW and GL_CCW are accepted. The initial value is GL_CCW.
    glFrontFace(GL_CW);
    // Specifies whether front- or back-facing facets are candidates
    // for culling. Symbolic constants GL_FRONT, GL_BACK, and
    // GL_FRONT_AND_BACK are accepted. The initial value is GL_BACK.
    glCullFace(GL_FRONT);
    // Enable or disable server-side GL capabilities
    glEnable(GL_CULL_FACE); // Face culling allows you to completely avoid rasterizing faces that you know won't show up.
    glEnable(GL_DEPTH_TEST); // If enabled, do depth comparisons and update the depth buffer.


    // The QMatrix4x4 class represents a 4x4
    // transformation matrix in 3D space.
    QMatrix4x4 modelview;
    // Multiples this matrix by another that rotates coordinates
    // through angle degrees about vector.

    // Set camera position.
    modelview.lookAt(QVector3D(0.0f, 0.0f, this->m_fRadius),
                     QVector3D(0.0f, 0.0f, 0.0f),
                     QVector3D(0.0f, 1.0f, 0.0f));

    modelview.rotate(m_fAngle_y, 1.0f, 0.0f, 0.0f); // Rotate y-axis
    modelview.rotate(m_fAngle_x, 0.0f, 1.0f, 0.0f); // Rotate x-axis
    //modelview.rotate(m_fAngle, 0.0f, 0.0f, 1.0f); // Rotate z-axis
    // Multiplies this matrix by another that scales coordinates by the components of vector.
    modelview.scale(m_fScale);
    // Multiplies this matrix by another that translates coordinates by the components x, y, and z.
    //modelview.translate(0.0f, -0.2f, 0.0f);

    // Binds this shader program to the active QGLContext and makes it the current shader program. Any previously bound shader program is released.
    this->program.bind();
    // Sets the uniform variable at location in the current context to value.
    this->program.setUniformValue(matrixUniform, modelview);
    //this->paintTexturedCube();
    this->setSphereVertex(m_fRadius, m_nSlices, m_nStacks);
    // Releases the active shader program from the current QGLContext. This is equivalent to calling glUseProgram(0).
    this->program.release();


    // Enable or disable server-side GL capabilities
    glDisable(GL_CULL_FACE); // Face culling allows you to completely avoid rasterizing faces that you know won't show up.
    glDisable(GL_DEPTH_TEST); // If enabled, do depth comparisons and update the depth buffer.

    painter.endNativePainting();

    QString framesPerSecond;
    framesPerSecond.setNum(this->frames /(this->time.elapsed() / 1000.0), 'f', 2);

    if(this->m_framerate)
    {
        painter.setPen(Qt::white);
        painter.drawText(0, 20, framesPerSecond + " fps");

        if (!(this->frames )) {//% 100
            this->time.start();
            this->frames = 0;
        }


                 if (this->frames ==count_frames) {

         //     QMessageBox msgBox;
         //     msgBox.setText(framesPerSecond);
         //    msgBox.exec();

             this->SetOpenGL_ES(framesPerSecond);
            this->SetResTest(framesPerSecond);
         //    this->SetOpenGL_ES(framesPerSecond);
            painter.end();
             this->hide();
             this->deleteLater();
             return;
                         }

        this->frames ++;
    }

    painter.end();

    // Swaps the screen contents with an off-screen buffer.
    // This only works if the widget's format specifies double buffer mode.
    this->swapBuffers();


    if(this->rotate)
    {
        int newAngle = this->m_fAngle_x + 1.0f;

        if(newAngle > 360)
            this->m_fAngle_x = newAngle - 360;
        else
            this->m_fAngle_x = newAngle;
    }

}


