#include "include/hdtest.h"
#include "ui_hdtest.h"

HDTest::HDTest(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::HDTest)
{
    ui->setupUi(this);
    connect(ui->pushButton,SIGNAL(clicked()),this,SLOT(startTest()));
    ui->progressBar_big_r->setValue(0);
    ui->progressBar_big_w->setValue(0);
    ui->progressBar_big_rw->setValue(0);
    ui->progressBar_ltl_rw->setValue(0);
    ui->progressBar_ltl_r->setValue(0);
    ui->progressBar_ltl_w->setValue(0);
    ui->progressBar_sec->setValue(0);
    ui->progressBar_sec_big->setValue(0);
    ui->label_15->setVisible(false);
    ui->label_16->setVisible(false);
    //ui->lineEdit_l_count->setVisible(false);
    ui->lineEdit_l_count_sec->setVisible(false);
    ui->lineEdit_b_count_sec->setVisible(false);
    ui->lineEdit_sec->setVisible(false);
    ui->lineEdit_sec_big->setVisible(false);
    ui->progressBar_sec->setVisible(false);
    ui->progressBar_sec_big->setVisible(false);
    ui->label_13->setVisible(false);
    ui->label_14->setVisible(false);


    setWindowTitle(QString::fromUtf8("Тест информационного носителя"));
}

HDTest::~HDTest()
{
    delete ui;
}
void HDTest::init_form(int l_count, int b_count, int l_size, int b_size)
{

    ui->lineEdit_l_count->setText(QString::number(l_count));
    ui->lineEdit_b_count->setText(QString::number(b_count));
    ui->lineEdit_l_size->setText(QString::number(l_size));
    ui->lineEdit_b_size->setText(QString::number(b_size));

}


char* HDTest::createBlock(uint size)
{
  char * memblock = new char [size];
  char abc[] = "qwertyuiopasdfghjklzxcvbnm";
    uint i = 0;
    uint j=0;
    while(j<size)
    {
        if(i < strlen(abc))
            memblock[j] = abc[i];
        else
        {
            memblock[j]=abc[0];
            i=0;
        }
        i++;
        j++;
    }
    return memblock;
}

int HDTest::Write(int size, QString Path, char* memblock)
{
  int file_d = open(qPrintable(Path), O_CREAT | O_WRONLY | O_TRUNC | O_SYNC , S_IRWXU);
  if (file_d == -1)
    return 1;
  posix_fadvise(file_d, 0, size , POSIX_FADV_DONTNEED);
  int write_val = write(file_d, memblock,size);
  ::close(file_d);
  if ( write_val != size)
    return 2;
  return 0;
}

int HDTest::Read(int size, QString Path)
{
    int size_block = 900;
    if (size<1000) size_block=size;
    int file_d = ::open(qPrintable(Path),O_RDONLY|O_SYNC);
    posix_fadvise(file_d, 0, size , POSIX_FADV_DONTNEED);
    char * memblock = new char[size_block];
    FILE * in = fdopen(file_d, "r");
    setbuf(in,NULL);
    while (fread(memblock,size_block, 1, in));
    fclose(in);
    delete[] memblock;
    return 0;
}

int HDTest::get(int fd, long pos, char *buf, int n)
{
    if (lseek(fd, pos, 0) >= 0) // установка позиции
    return read(fd, buf, n);
    else
    return -1;
}

quint64 HDTest::countSpeed(quint64 msec, quint64 size)
{
  quint64 sp=0;
  if(msec>1)
  {
    sp = size*1000;
    sp = sp/msec;
  }
  return sp;
}
QString HDTest::getStr(ReadWrite rw)
{
    if (rw.err==0)
        return QString("%1 KB/sec").arg(rw.speed);
    return "Error";
}

void HDTest::writeTest(QString path, int size, int count)
{
  ReadWrite r = {0,1};
  ui->progressBar_big_w->setMaximum(100);
  ui->progressBar_big_w->setValue(0);
  char * memblock = createBlock(size);
  QTime T = T.currentTime();
  for (int j=0; j<count; j++)
  {
    QString Path =path + QString("tmp_%1").arg(j);
    if(Write(size,Path, memblock)!=0) return;
    ui->progressBar_big_w->setValue((quint64)((j+1)*100)/ count);
  }
  QTime T1 = T1.currentTime();
  delete[] memblock;
  r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size*count)/1024);
  r.err=0;
  ui->lineEdit_big_w->setText(getStr(r));
  return;
}
void HDTest::readTest(QString path, int size, int count)
{
    ReadWrite r = {0,1};
    ui->progressBar_big_r->setMaximum(100);
    ui->progressBar_big_r->setValue(0);
    QTime T = T.currentTime();
    for (int j=0; j<count; j++)
    {
      QString Path =path + QString("tmp_%1").arg(j);
      if(Read(size,Path)!=0) return;
      ui->progressBar_big_r->setValue((quint64)((j+1)*100)/ count);
    }
    QTime T1 = T1.currentTime();
    r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size*count)/1024);
    r.err=0;
    ui->lineEdit_big_r->setText(getStr(r));
    return;
}
// LITTLE !!!
void HDTest::writeTestLtl(QString path, int size, int count)
{
  ReadWrite r = {0,1};
  ui->progressBar_ltl_w->setMaximum(100);
  ui->progressBar_ltl_w->setValue(0);
  char * memblock = createBlock(size);
  QTime T = T.currentTime();
  for (int j=0; j<count; j++)
  {
    QString Path =path + QString("tmp_ltl_%1").arg(j);
    if(Write(size,Path, memblock)!=0) return;
    ui->progressBar_ltl_w->setValue((quint64)((j+1)*100)/ count);
  }
  QTime T1 = T1.currentTime();
  delete[] memblock;
  r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size*count)/1024);
  r.err=0;
  ui->lineEdit_ltl_w->setText(getStr(r));
  return;
}
void HDTest::readTestLtl(QString path, int size, int count)
{
    ReadWrite r = {0,1};
    ui->progressBar_ltl_r->setMaximum(100);
    ui->progressBar_ltl_r->setValue(0);
    QTime T = T.currentTime();
    for (int j=0; j<count; j++)
    {
      QString Path =path + QString("tmp_ltl_%1").arg(j);
      if(Read(size,Path)!=0) return;
      ui->progressBar_ltl_r->setValue((quint64)((j+1)*100)/ count);
    }
    QTime T1 = T1.currentTime();
    r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size*count)/1024);
    r.err=0;
    ui->lineEdit_ltl_r->setText(getStr(r));
    return;
}

// ALTERNATION

void HDTest::altTesBig(QString path, int size, int count)
{
    ReadWrite r = {0,1};
    ui->progressBar_big_rw->setMaximum(100);
    ui->progressBar_big_rw->setValue(0);
    char * memblock = createBlock(size);
    QTime T = T.currentTime();
    for (int j=0; j<count; j++)
    {
      QString Path =path + QString("tmp_alt_%1").arg(j);
      if(Write(size,Path,memblock)!=0) return;
      if(Read(size,Path)!=0) return;
      ui->progressBar_big_rw->setValue((quint64)((j+1)*100)/ count);
    }
    QTime T1 = T1.currentTime();
    delete[] memblock;
    for (int j=0; j<count; j++)
    {
        QString Path =path + QString("tmp_alt_%1").arg(j);
        remove(qPrintable(Path));
    }
    r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size*count)/1024);
    r.err=0;
    ui->lineEdit_big_rw->setText(getStr(r));
    return;
}
QString HDTest::getDir()
{
    QDir().mkdir("/tmp/HDTest/");
    QString Dir = "/tmp/HDTest/";
    QString warn;
    if (rightPass(Dir,warn))
        return Dir;
    return "Error";
}

void HDTest::altTesLtl(QString path, int size, int count)
{
    ReadWrite r = {0,1};
    ui->progressBar_ltl_rw->setMaximum(100);
    ui->progressBar_ltl_rw->setValue(0);
    char * memblock = createBlock(size);
    QTime T = T.currentTime();
    for (int j=0; j<count; j++)
    {
      QString Path =path + QString("tmp_alt_%1").arg(j);
      if(Write(size,Path,memblock)!=0) return;
      if(Read(size,Path)!=0) return;
      ui->progressBar_ltl_rw->setValue((quint64)((j+1)*100)/ count);
    }
    QTime T1 = T1.currentTime();
    delete[] memblock;
    r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size*count)/1024);
    r.err=0;
    ui->lineEdit_ltl_rw->setText(getStr(r));
    for (int j=0; j<count; j++)
    {
        QString Path =path + QString("tmp_alt_%1").arg(j);
        remove(qPrintable(Path));
    }
    return;
}
// Sector



int HDTest::SectorRead(int count)
{
    ReadWrite r = {0,1};
    QString diskName = getActiveHDD();
    long count_sec = getSizeHDD().toLong()*2;
    int size_sec = 512;
    ui->progressBar_sec->setMaximum(100);
    ui->progressBar_sec->setValue(0);
    qsrand (QTime(0,0,0).msecsTo(QTime::currentTime()));
    //ui->lineEdit_2->setText(diskName);
    //ui->lineEdit_3->setText(QString("%1").arg(count_sec));
    long * numbers = new long[count];
    for (int i=0;i<count;i++)
    {
        numbers[i] = qrand() % count_sec;
        //std::cerr<<numbers[i]<<" "<<std::endl;
    }
    int file_d = ::open(qPrintable(diskName),O_RDONLY|O_SYNC);
    if (file_d == -1)
        return 1;
    char * memblock = new char[size_sec];
    QTime T = T.currentTime();
    for (int i=0; i<count; i++)
    {
        int pos = size_sec*numbers[i];
        posix_fadvise(file_d, pos, size_sec , POSIX_FADV_DONTNEED);
        get(file_d,pos, memblock,size_sec);
        ui->progressBar_sec->setValue((quint64)((i+1)*100)/ count);
    }
    QTime T1 = T1.currentTime();
    r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size_sec*count)/1024);
    r.err=0;
    ui->lineEdit_sec->setText(getStr(r));
    ::close(file_d);
    delete[] memblock;
    delete[] numbers;
    return 0;
}

int HDTest::SectorReadMany(int count)
{
    ReadWrite r = {0,1};
    QString diskName = getActiveHDD();
    long count_sec = getSizeHDD().toLong()*2;
    int size_sec = 512;
    ui->progressBar_sec_big->setMaximum(100);
    ui->progressBar_sec_big->setValue(0);
    qsrand (QTime(0,0,0).msecsTo(QTime::currentTime()));
    //qsrand (QDateTime::currentMSecsSinceEpoch());
    //ui->lineEdit_2->setText(diskName);
    //ui->lineEdit_3->setText(QString("%1").arg(count_sec));
    long * numbers = new long[count];
    for (int i=0;i<count;i++)
    {
        numbers[i] = qrand() % count_sec;
        //std::cerr<<numbers[i]<<" "<<std::endl;
    }
    int file_d = ::open(qPrintable(diskName),O_RDONLY|O_SYNC);
    if (file_d == -1)
        return 1;
    char * memblock = new char[size_sec];
    QTime T = T.currentTime();
    for (int i=0; i<count; i++)
    {
        int pos = size_sec*numbers[i];
        posix_fadvise(file_d, pos, size_sec , POSIX_FADV_DONTNEED);
        get(file_d,pos, memblock,size_sec);
        ui->progressBar_sec_big->setValue((quint64)((i+1)*100)/ count);
    }
    QTime T1 = T1.currentTime();
    r.speed= countSpeed((quint64)(T.msecsTo(T1)),(size_sec*count)/1024);
    r.err=0;
    ui->lineEdit_sec_big->setText(getStr(r));
    ::close(file_d);
    delete[] memblock;
    delete[] numbers;
    return 0;
}

QString HDTest::getActiveHDD()
{
    run("./getDiskname.sh");
    QString result="";
    QString cifra = "1234567890";
    QString str = tmp;
    for (int i =0; i<str.size(); i++)
    {
        for (int j=0; j< cifra.size(); j++)
            if(str[i] ==cifra[j])
                return result;
        result+=str[i];
    }
    return result;
}

QString HDTest::getSizeHDD()
{
    run("./getSizeHDD.sh");
    return tmp;
}

void HDTest::finished()
{
    arr = new QByteArray();
    *arr = console->readAllStandardError();
    tmp = arr->data();
}

void HDTest::run(char * filename)
{
    console = new QProcess;
    connect(console, SIGNAL(finished(int,QProcess::ExitStatus)), this, SLOT(finished()));
    console->setReadChannel (QProcess::StandardError);
    console->start(filename);
    console->waitForFinished();
}


void HDTest::Clear(QString path, int count, bool isBig=true)
{
    for (int j=0; j<count; j++)
    {
      QString Path;
      if(isBig)  Path =path + QString("tmp_%1").arg(j);
      else  Path =path + QString("tmp_ltl_%1").arg(j);
      remove(qPrintable(Path));
    }
}

bool HDTest::rightPass(QString &dir, QString &warn)
{
    if (!(QChar ('/')==dir[dir.size()-1]))
      dir+=QChar('/');

    QDir * Dir = new QDir(dir);
    QFile file(Dir->filePath("ex1.txt"));
    if (!Dir->exists(dir)) {
        warn = QString("Directory doesn' exists");
       // qWarning("Directory doesn' exists");
        return false;
    }
    if (!file.open(QIODevice::ReadWrite))
    {
        warn = QString("You are not allowed to use this directory");
       // qWarning("You are not allowed to use this directory");
        return false;
    }
    remove(qPrintable(dir+"ex1.txt"));
    return true;
}

void HDTest::startTest()
{
    ui->progressBar_big_r->setValue(0);
    ui->progressBar_big_w->setValue(0);
    ui->progressBar_big_rw->setValue(0);
    ui->progressBar_ltl_rw->setValue(0);
    ui->progressBar_ltl_r->setValue(0);
    ui->progressBar_ltl_w->setValue(0);
    ui->progressBar_sec->setValue(0);
    ui->progressBar_sec_big->setValue(0);
    QString path = getDir();
    if(path == "Error")
    {
        path = QDir::currentPath();
        QString warn;
        if (!rightPass(path,warn)) return;
    }
    //ui->label_6->setText(path);

    int l_count =ui->lineEdit_l_count->text().toInt();
    int count = ui->lineEdit_b_count->text().toInt();
    int l_size =ui->lineEdit_l_size->text().toInt();
    int size=ui->lineEdit_b_size->text().toInt()*1024*1024;
    //int count_sec_ltl = ui->lineEdit_l_count_sec->text().toInt();
    //int count_sec_big = ui->lineEdit_b_count_sec->text().toInt();

    writeTestLtl(path,l_size,l_count);
    writeTest(path,size,count);

    readTestLtl(path,l_size,l_count);
    readTest(path,size,count);


    Clear(path,count);
    Clear(path,l_count,false);

    altTesLtl(path,l_size,l_count);
    altTesBig(path,size,count);
    //if (SectorRead(count_sec_ltl)!=0)
    //    ui->lineEdit_sec->setText("Permission Denied");
    //if (SectorReadMany(count_sec_big)!=0)
    //    ui->lineEdit_sec_big->setText("Permission Denied");

  // void signal_Set_value_HDD(QString wl, QString wb, QString rl, QString rb, QString rwl, QString rwb);
    signal_Set_value_HDD(
            ui->lineEdit_ltl_w->text(),
            ui->lineEdit_big_w->text(),
            ui->lineEdit_ltl_r->text(),
            ui->lineEdit_big_r->text(),
            ui->lineEdit_ltl_rw->text(),
            ui->lineEdit_big_rw->text()
            );
 this->hide();
}


