#include <QtGui/QApplication>
#include <QtCore>
#include <QWidget>
#include <QtGui>
#include <QMessageBox>
#include <QDateTime>
#include "include/mainwindow.h"
#include "ui_mainwindow.h"
#include "ui_mainform.h"
#include <sys/utsname.h>
#include <QSysInfo>
#include <string.h>
#include  "include/dialog.h"
#include  "include/form.h"
#include "include/map2d.h"
#include "globe/ot_proj.h"
#include <QtXml>
//#include "include/glwidget.h"
//#include "include/globe_es.h"
#include "include/dqimage.h"
#include <QTimer>
#include "include/memtest.h"
#include "include/myclient.h"
#include "include/hdtest.h"
/*void Counter::setValue(int value)
 {
     if (value != m_value) {
         m_value = value;
         emit valueChanged(value);
     }
 }
*/
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow),
    m_settings("RTI","RTIbanchmark")


{

    ui->setupUi(this);
  //
   //setWindowTitle(toUtf8("Оценка производительности средств ВТ"));
    // MainWindow::osVersion();

   Readinit();
   QString str;
   str.setNum(++id_test);

   QString message = trUtf8(" версия ОС : ")+ MainWindow::osVersion()+ trUtf8("| Тест запущен:")+ QDateTime::currentDateTime().toString("dd/MM/yyyy hh:mm:ss")+
                     trUtf8("| id теста:")+ str;
    statusBar()->showMessage(message);

    ui->tabWidget->setCurrentIndex(1);
  //  ui->tabWidget->setTabEnabled(2,false);
   // ui->tabWidget->setTabEnabled(3,false);
  //  ui->tabWidget->setTabEnabled(4,false);
    ui->pushButton_map2d_2->setVisible(false);
    QObject::connect(ui->pushButton_CPU,SIGNAL(clicked()),this,SLOT(StartTestCPU()));
    QObject::connect(ui->pushButton_VGA,SIGNAL(clicked()),this,SLOT(StartTestVGA()));
    QObject::connect(ui->pushButton_RAM,SIGNAL(clicked()),this,SLOT(StartTestRAM()));

    QObject::connect(ui->pushButton_inteface,SIGNAL(clicked()),this,SLOT(StartTest_inteface()));
    QObject::connect(ui->pushButton_map2d,SIGNAL(clicked()),this,SLOT(StartTest_map2d()));
    QObject::connect(ui->pushButton_map2d_2,SIGNAL(clicked()),this,SLOT(StartTest_map2dqimage()));
    QObject::connect(ui->pushButton_3d,SIGNAL(clicked()),this,SLOT(StartTest_3d()));
  //  QObject::connect(ui->pushButton_3dES,SIGNAL(clicked()),this,SLOT(StartTest_3d_es()));
    QObject::connect(ui->pushButton_net,SIGNAL(clicked()),this,SLOT(StartTestNet()));
    QObject::connect(ui->pushButton_HDD,SIGNAL(clicked()),this,SLOT(StartTestHDD()));

    QObject::connect(ui->pushButton_xml,SIGNAL(clicked()),this,SLOT(SaveResult()));
    QObject::connect(ui->pushButton_2,SIGNAL(clicked()),this,SLOT(ReadResult()));
    QObject::connect(ui->pushButton_all,SIGNAL(clicked()),this,SLOT(StartAllTests()));


   // readSettings();
  //   QTime start_time = QTime::currentTime();
      ReadResult();
ui->pushButton_xml->setVisible(false);
ui->pushButton_2->setVisible(false);
//ui->toolBox_VGA->setVisible(false);
}

MainWindow::~MainWindow()
{
   // writeSettings();
    delete ui;

}


void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainWindow::setWorkDir(QString& dir)
{
    m_workDir = dir;

}
QString MainWindow::getWorkDir()
{
    return m_workDir;

}


//void MainWindow::on_pushButton_clicked()
//{
//int i=1;
//}

void MainWindow::StartAllTests()
{
 //   ui->pushButton_CPU->setEnabled(false);
  //  ui->pushButton_VGA->setEnabled(false);
    // OTGlobe *m_globe = new OTGlobe(this) ;
    //  m_globe->setTexturesDir(m_workDir.toAscii().data());
     // m_globe->resizeGL(this->width(),this->height());
      // printf("WorkDir: %s\n",m_workDir.toAscii().data());
    //  m_globe->initializeGL();//m_workDir);


Saveinit();
//закоментировано для запуска тестов только графики
//ui->tabWidget->setCurrentIndex(0);
//StartTestCPU();
ui->tabWidget->setCurrentIndex(1);
ui->tabWidget->repaint();

StartTestVGA();
ui->tabWidget->repaint();
//ui->tabWidget->setCurrentIndex(3);
//StartTestRAM();
//ui->tabWidget->repaint();
//ui->tabWidget->setCurrentIndex(4);
//StartTestHDD();
//ui->tabWidget->repaint();
//ui->tabWidget->setCurrentIndex(2);
//StartTestNet();

SaveResult();


 QMessageBox msgBox;
 msgBox.setText(trUtf8(" Тестирование завершено. Результаты сохранены."));
 msgBox.exec();

}


// Определение версии ОС
QString MainWindow::osVersion()
{
    static QString osVersion;
    if(osVersion.isEmpty())
    {
#if defined(Q_OS_LINUX)
 utsname buf;
 if(uname(&buf) != -1)
 {
  osVersion.append(buf.release).append(QLatin1Char(' '));
  osVersion.append(buf.sysname).append(QLatin1Char(' '));
  osVersion.append(buf.machine).append(QLatin1Char(' '));
  osVersion.append(QLatin1String(" (")).append(buf.machine).append(QLatin1Char(')'));
 }
 else
 {
  osVersion = QLatin1String("Linux(unknown)");
 }
#elif defined(Q_OS_MAC)
 switch(QSysInfo::MacintoshVersion)
 {
  case QSysInfo::MV_LEOPARD:
   osVersion = QLatin1String("MacOS 10.5(Leopard)");
   break;
  case QSysInfo::MV_TIGER:
   osVersion = QLatin1String("MacOS 10.4(Tiger)");
   break;
  case QSysInfo::MV_PANTHER:
   osVersion = QLatin1String("MacOS 10.3(Panther)");
   break;
  case QSysInfo::MV_JAGUAR:
   osVersion = QLatin1String("MacOS 10.2(Jaguar)");
   break;
  case QSysInfo::MV_PUMA:
   osVersion = QLatin1String("MacOS 10.1(Puma)");
   break;
  case QSysInfo::MV_CHEETAH:
   osVersion = QLatin1String("MacOS 10.0(Cheetah)");
   break;
  case QSysInfo::MV_9:
   osVersion = QLatin1String("MacOS 9");
   break;
   case QSysInfo::MV_Unknown:
  default:
   osVersion = QLatin1String("MacOS(unknown)");
   break;
 }
#elif defined(Q_OS_WIN)
 switch(QSysInfo::WindowsVersion)
 {
  case QSysInfo::WV_CE_6:
   osVersion = QLatin1String("Windows CE 6.x");
   break;
  case QSysInfo::WV_CE_5:
   osVersion = QLatin1String("Windows CE 5.x");
   break;
  case QSysInfo::WV_CENET:
   osVersion = QLatin1String("Windows CE .NET");
   break;
  case QSysInfo::WV_CE:
   osVersion = QLatin1String("Windows CE");
   break;
   case QSysInfo::WV_WINDOWS7:
   osVersion = QLatin1String("Windows 7, Windows Server 2008 R2 (operating system version 6.1)");
   break;
   case QSysInfo::WV_VISTA:
   osVersion = QLatin1String("Windows Vista");
   break;
  case QSysInfo::WV_2003:
   osVersion = QLatin1String("Windows Server 2003");
   break;
  case QSysInfo::WV_XP:
   osVersion = QLatin1String("Windows XP");
   break;
  case QSysInfo::WV_2000:
   osVersion = QLatin1String("Windows 2000");
   break;
  case QSysInfo::WV_NT:
   osVersion = QLatin1String("Windows NT");
   break;
   case QSysInfo::WV_Me:
   osVersion = QLatin1String("Windows Me");
   break;
  case QSysInfo::WV_98:
   osVersion = QLatin1String("Windows 98");
   break;
  case QSysInfo::WV_95:
   osVersion = QLatin1String("Windows 95");
   break;
  case QSysInfo::WV_32s:
   osVersion = QLatin1String("Windows 3.1 with Win32s");
   break;
   default:
   osVersion = QLatin1String("Windows(unknown)");
   break;
 }
 if(QSysInfo::WindowsVersion & QSysInfo::WV_CE_based)
  osVersion.append(QLatin1String(" (CE-based)"));
 else if(QSysInfo::WindowsVersion & QSysInfo::WV_NT_based)
  osVersion.append(QLatin1String(" (NT-based)"));
 else if(QSysInfo::WindowsVersion & QSysInfo::WV_DOS_based)
  osVersion.append(QLatin1String(" (MS-DOS-based)"));
#else
  return QLatin1String("Unknown");
#endif
    }

return osVersion;
};

void MainWindow::StartTestCPU()
{

 //  QString procname(enviropments::getCPU_name());
 //  QMessageBox msgBox;
   //proc=enviropments::getCPU_name();
 //   msgBox.setText(trUtf8("  Наименование процессора: \n")+proc.toAscii());
 //   msgBox.exec();

    //    ui->label_CPU_Name->setText(enviropments::getCPU_name());
    //    ui->label_CPU_MHz->setText(enviropments::getCPU_MHz());
     //   ui->label_CPU_NProc->setText(enviropments::getCPU_NProc());
//QString str = enviropments::getCPU_name();
//str.remove(QLatin1Char('\n'));
//ui->tableWidget_CPU->item(0,0)->setText(procname.replace("\a","").trimmed().toAscii());
ui->tableWidget_CPU->item(0,0)->setText(enviropments::getCPU_name());

//&setText(enviropments::getCPU_MHz()
ui->tableWidget_CPU->item(1,0)->setText(enviropments::getCPU_MHz());
ui->tableWidget_CPU->item(2,0)->setText(enviropments::getCPU_NProc());

//..        ui->label_status->setText(trUtf8("тестирование проведено"));
QIcon qicon;
qicon.addFile(":/res/res/CPU-icon_OK.png");
ui->tabWidget->setTabIcon(0,qicon);

//ui->tabWidget->currentWidget()->setWindowIcon(qicon);

  // //ui->tab_CPU->show();

  //      QPixmap pmap(QString(trUtf8(":/src/src/camera_test.png")));
   //     if (pmap.isNull())
  //            ui->label_status_ico->setText("Null pixmap!");
  //      else
//            ui->label_status_ico->setPixmap(pmap);

    }


// запуск Теста графики
void MainWindow::StartTestVGA()
{

QString vga_name(enviropments::getVGA_Name());
if (vga_name.length()>1)
        {
        ui->tableWidget_VGA->item(0,0)->setText(vga_name);
        }



QString vga__isOpenGL(enviropments::getVGA_isOpenGL());
//QString vga__isOpenGL=trUtf8("OpenGL не поддерживается");

//vga__isOpenGL=enviropments::getVGA_isOpenGL();
//vga__isOpenGL.trimmed();
int x=QString::compare(vga__isOpenGL,"Yes",Qt::CaseInsensitive);
if (x==0)
                   {

        ui->tableWidget_VGA->item(1,0)->setText(trUtf8("OpenGL поддерживается"));
        }
else ui->tableWidget_VGA->item(1,0)->setText(trUtf8("OpenGL не поддерживается"));



// возвращает тип видеоадаптера или строку Встроенный видеоадаптер
QString vga__V(enviropments::getVGA_V());
vga__V.trimmed();
//int x=QString::compare(vga__isOpenGL,"Yes");
//if (x==1)
     if (vga__V.length()>1)
{
ui->tableWidget_VGA->item(2,0)->setText(vga__V);
}
else ui->tableWidget_VGA->item(2,0)->setText(trUtf8("Встроенный видеоадаптер"));

StartTest_inteface();
ui->tableWidget_VGA->repaint();
StartTest_map2d();
ui->tableWidget_VGA->repaint();
StartTest_3d();
//StartTest_3d_es();
// ui->tableWidget_VGA->item(1,0)->setText(enviropments::getCPU_MHz());
        //Изменение статуса
        QIcon qicon;
        qicon.addFile(":/res/res/graf-Ok.png");
        ui->tabWidget->setTabIcon(1,qicon);



    }




void MainWindow::StartTest_inteface()
{

        Form *fm;
       fm = new Form();
        fm->setAttribute(Qt::WA_DeleteOnClose);
fm->setWindowTitle(trUtf8("Тестирование оконного интерфейса"));
fm->show();
int count = ui->lineEdit_interface->text().toInt();
int time = fm->CalculateFPS(count);
 QString str;
   // saveResults(LOG_FILE,time,m_frameCount);
    //ui->label_interface->setText(str.sprintf("Result FPS: %0.3f",count*1000.0/time));
   ui->tableWidget_VGA->item(3,0)->setText(str.sprintf("%0.3f",count*1000.0/time));
fm->hide();
}
// для запуска из консоли
QString StartTest_inteface_console(int count_frame)
{
  Form *fm;
  fm = new Form();
  fm->setAttribute(Qt::WA_DeleteOnClose);
  fm->setWindowTitle(QObject::trUtf8("Тестирование оконного интерфейса"));
  fm->show();
  int time = fm->CalculateFPS(count_frame);
  QString str;
  str.sprintf("%0.3f",count_frame*1000.0/time);
  fm->hide();
return str;
}




void MainWindow::StartTest_map2d()
{

  Map2d  *map2d = new Map2d;
  map2d->setWorkDir(m_workDir);
 map2d->init2d(m_workDir);
 map2d->show();

    map2d->setWindowTitle(trUtf8("Тестирование 2d интерфейса"));

int count =ui->lineEdit_2dmap->text().toInt();
    int time = map2d->CalculateFPS(count);
     QString str;
       // saveResults(LOG_FILE,time,m_frameCount);
      ui->tableWidget_VGA->item(4,0)->setText(str.sprintf("%0.3f",count*1000.0/time));
    //    ui->label_interface->setText(str.sprintf("Result FPS: %0.3f",count*1000.0/time));
    map2d->hide();
    }

void MainWindow::StartTest_map2dqimage()
{

  dqimage  *wid2d = new dqimage;




  wid2d->setWorkDir(m_workDir);
 wid2d->init2d(m_workDir);
 //wid2d->loadImage(m_workDir);
 //
 // QImage image(m_workDir+"/textures/map_earth.bmp");

wid2d->setWindowTitle(trUtf8("Тестирование 2d интерфейса"));
wid2d->show();
wid2d->repaintquimage(0);

int count =ui->lineEdit_2dmap->text().toInt();
    int time = wid2d->CalculateFPS(count);
     QString str;
       // saveResults(LOG_FILE,time,m_frameCount);
      ui->tableWidget_VGA->item(6,0)->setText(str.sprintf("%0.3f",count*1000.0/time));
    //    ui->label_interface->setText(str.sprintf("Result FPS: %0.3f",count*1000.0/time));
// map2d->show();

 //   map2d->setWindowTitle(trUtf8("Тестирование 2d интерфейса"));

//int count =ui->lineEdit_2dmap->text().toInt();
 //   int time = map2d->CalculateFPS(count);
  //   QString str;
       // saveResults(LOG_FILE,time,m_frameCount);
//      ui->tableWidget_VGA->item(4,0)->setText(str.sprintf("%0.3f",count*1000.0/time));
    //    ui->label_interface->setText(str.sprintf("Result FPS: %0.3f",count*1000.0/time));
//    map2d->hide();
    }
QString StartTest_map2d_console(int count_frame, QString m_workDir)
{

  Map2d  *map2d = new Map2d;
  map2d->setWorkDir(m_workDir);
  map2d->init2d(m_workDir);
  map2d->show();

    map2d->setWindowTitle(QObject::trUtf8("Тестирование 2d интерфейса"));
    int time = map2d->CalculateFPS(count_frame);
    QString str;
    map2d->hide();
    str.sprintf("%0.3f",count_frame*1000.0/time);
    return str;
    }

void MainWindow::StartTest_3d()
{
  OTGlobe *m_globe = new OTGlobe();
  m_globe->show();
  m_globe->resize(600, 600);
  m_globe->setWindowTitle(trUtf8("Тестирование 3d интерфейса"));
  m_globe->initializeGL();

QTime m_time;
m_time.start();
 QString str;
m_globe->paintGL();
int count  = ui->lineEdit_3d->text().toInt();
for(int i=1;i<=count;i++)
    {
    m_globe->setWindowTitle(trUtf8("Тестирование 3d интерфейса:")+str.sprintf("Frames: %d",i));
      m_globe->rotate(0,1);
      m_globe->updateGL();
     }
m_globe->hide();
 ui->tableWidget_VGA->item(5,0)->setText(str.sprintf("%0.3f",count*1000.0/m_time.elapsed()));

//msgBox.setText(trUtf8(" time: \n")+vga_name.toAscii());
 //  msgBox.exec();
/*   OGLPyramid  *oglPyramid = new (OGLPyramid)  ;

   oglPyramid->resize(600, 600);
   oglPyramid->show();
oglPyramid->setWindowTitle(trUtf8("Тестирование 3d интерфейса"));
int count=ui->lineEdit_3d->text().toInt();
int time = oglPyramid->CalculateFPS(count);

 QString str;
ui->tableWidget_VGA->item(5,0)->setText(str.sprintf("%0.3f",count*1000.0/time));
oglPyramid->hide();*/
//oglPyramid->turn(1,3);void Memtest::Dinamic_RAM(int count,int blocksize )
//oglPyramid->m_xRotate=1;
       // m_xRotate += 180 * (GLfloat)(pe->y() - m_ptPosition.y()) / height();
//oglPyramid->m_xRotate=3;
//oglPyramid->updateGL();
   // form3d->show();
}

QString StartTest_3d_console(int count_frame)
{
  OTGlobe *m_globe = new OTGlobe();
  m_globe->show();
  m_globe->resize(600, 600);
  m_globe->setWindowTitle(QObject::trUtf8("Тестирование 3d интерфейса"));
  m_globe->initializeGL();

QTime m_time;
m_time.start();
 QString str;
m_globe->paintGL();
//int count  = ui->lineEdit_3d->text().toInt();
for(int i=1;i<=count_frame;i++)
    {
    m_globe->setWindowTitle(QObject::trUtf8("Тестирование 3d интерфейса:")+str.sprintf("Frames: %d",i));
      m_globe->rotate(0,1);
      m_globe->updateGL();
     }
str.sprintf("%0.3f",count_frame*1000.0/m_time.elapsed());
m_globe->hide();
 return str;


}


/*void MainWindow::StartTest_3d_es()
{
QSize w_size(600, 600);
GlobeWidget *globe3des = new GlobeWidget();


globe3des->setMinimumSize(w_size); 1.5
globe3des->setMaximumSize(w_size);
globe3des->setWindowTitle(trUtf8("Тестирование 3d OpenGL ES"));

QTimer *timer = new QTimer(globe3des);

QEventLoop loop;

//timer->setInterval(1);

QObject::connect(timer, SIGNAL(timeout()), globe3des, SLOT(updateGL()));
QObject::connect(&counter1, SIGNAL(valueChanged(int)), globe3des, SLOT(updateGL()));
//QObject::connect(globe3des, SIGNAL(Hidewidget()), glwid, SLOT(hide()));

QObject::connect(globe3des, SIGNAL(SetOpenGL_ES(QString)), &loop, SLOT(quit()));
globe3des->count_frames= ui->lineEdit_3d->text().toInt();
globe3des->show();
timer->start();

//для того чтобы дождаться завершения теста 3d ES запускаем  цикл обработки событий
// как только появился результат выходим из цикла обработки событий
QObject::connect(globe3des, SIGNAL(SetOpenGL_ES(QString)), this, SLOT(Set_3d_es(QString)));
loop.exec();
}

QString StartTest_3d_es_console(int count_frame)
{
    QSize w_size(600, 600);
    GlobeWidget *globe3des = new GlobeWidget();


    globe3des->setMinimumSize(w_size);1.5
    globe3des->setMaximumSize(w_size);
    globe3des->setWindowTitle(QObject::trUtf8("Тестирование 3d OpenGL ES"));

    QTimer *timer = new QTimer(globe3des);

    QEventLoop loop;
    globe3des->count_frames= count_frame;
    //timer->setInterval(1);

    QObject::connect(timer, SIGNAL(timeout()), globe3des, SLOT(updateGL()));
    //QObject::connect(&counter1, SIGNAL(valueChanged(int)), globe3des, SLOT(updateGL()));
    //QObject::connect(globe3des, SIGNAL(Hidewidget()), glwid, SLOT(hide()));


  //  QObject::connect(globe3des, SIGNAL(SetResTest(QString)), &loop, SLOT(quit()));
QObject::connect(globe3des, SIGNAL(SetOpenGL_ES(QString)), globe3des , SLOT(SetResTest(QString)));
    QObject::connect(globe3des, SIGNAL(SetOpenGL_ES(QString)), &loop, SLOT(quit()));

    globe3des->show();
    timer->start();


    //для того чтобы дождаться завершения теста 3d ES запускаем  цикл обработки событий
    // как только появился результат выходим из цикла обработки событий
    loop.exec();
     QString str;

      str =globe3des->GetResTest();

     return str;
}

void MainWindow::Set_3d_es(QString str)
{

ui->tableWidget_VGA->item(6,0)->setText(str);
}

void MainWindow::Set_3d_es_console(QString str)
{

ui->tableWidget_VGA->item(6,0)->setText(str);
}


void MainWindow::on_pushButton_CPU_clicked()
{

}*/

void MainWindow::Set_ram_size_count(int size, quint64 count)
 {
    ui->lineEdit_ram_size->setText(QString::number(size));
     ui->lineEdit_ram_count->setText(QString::number(count));
 }




//*****************    RAM    **************************
// запуск Теста оперативной памяти
void MainWindow::StartTestRAM()
{

QString ram_total(enviropments::getRAM_Total());
if (ram_total.length()>1)
        {
        ui->tableWidget_RAM->item(1,0)->setText(ram_total);
        }

QString ram_free(enviropments::getRAM_Free());
if (ram_free.length()>1)
        {
        ui->tableWidget_RAM->item(2,0)->setText(ram_free);
        }

Memtest *memwidget = new Memtest();
memwidget->setWindowTitle(QObject::trUtf8("Тестирование оперативной памяти"));
memwidget->show();
memwidget->Set_size_count(ui->lineEdit_ram_size->text().toInt(),(quint64)ui->lineEdit_ram_count->text().toLongLong());
QObject::connect(memwidget, SIGNAL(Set_size_count_signal(int,quint64)), this , SLOT(Set_ram_size_count(int,quint64)));
QObject::connect(memwidget, SIGNAL(signal_Set_value_RAM(QString,QString,QString,QString,QString,QString)), this , SLOT(slot_Set_value_RAM(QString,QString,QString,QString,QString,QString)));
memwidget->StartTestRAM();

QIcon qicon;
qicon.addFile(":/res/res/RAM_OK.png");
ui->tabWidget->setTabIcon(3,qicon);
/*
progressBar_1
QString vga__isOpenGL(enviropments::getVGA_isOpenGL());
//QString vga__isOpenGL=trUtf8("OpenGL не поддерживается");

//vga__isOpenGL=enviropments::getVGA_isOpenGL();
//vga__isOpenGL.trimmed();
int x=QString::compare(vga__isOpenGL,"Yes",Qt::CaseInsensitive);
if (x==0)
                   {

        ui->tableWidget_VGA->item(1,0)->setText(trUtf8("OpenGL поддерживается"));
        }
else ui->tableWidget_VGA->item(1,0)->setText(trUtf8("OpenGL не поддерживается"));



// возвращает тип видеоадаптера или строку Встроенный видеоадаптер
QString vga__V(enviropments::getVGA_V());
vga__V.trimmed();
//int x=QString::compare(vga__isOpenGL,"Yes");
//if (x==1)
     if (vga__V.length()>1)
{
ui->tableWidget_VGA->item(2,0)->setText(vga__V);
}
else ui->tableWidget_VGA->item(2,0)->setText(trUtf8("Встроенный видеоадаптер"));


StartTest_inteface();
StartTest_map2d();
StartTest_3d();
StartTest_3d_es();
// ui->tableWidget_VGA->item(1,0)->setText(enviropments::getCPU_MHz());
        //Изменение статусаprogressBar_1
        QIcon qicon;
        qicon.addFile(":/res/res/graf-Ok.png");
        ui->tabWidget->setTabIcon(1,qicon);
*/


    }
void MainWindow::slot_Set_value_RAM(QString sw, QString sr, QString srw, QString dw, QString dr, QString drw)
{
    ui->tableWidget_RAM->item(3,0)->setText(sw);
    ui->tableWidget_RAM->item(4,0)->setText(sr);
    ui->tableWidget_RAM->item(5,0)->setText(srw);
    ui->tableWidget_RAM->item(6,0)->setText(dw);
    ui->tableWidget_RAM->item(7,0)->setText(dr);
    ui->tableWidget_RAM->item(8,0)->setText(drw);
}


//*****************    NET   **************************
// запуск Теста Сетевой карты
void MainWindow::StartTestNet()
{
    QString ports_count(enviropments::get_ports_count());

            ui->tableWidget_NET->item(0,0)->setText(ports_count);



//MyClient     client;
    //MyClient     client("localhost", 2323);
 //client.show();

// MyClient *client = new MyClient("localhost", 2323);
 MyClient *client = new MyClient(ui->lineEdit_net_ip->text().toAscii(), ui->lineEdit_net_port->text().toInt());

 client->setWindowTitle(QObject::trUtf8("Тестирование  сетевой карты"));
// client->set_count_blocksize(100,100);

  client->set_count_blocksize(ui->lineEdit_net_count->text().toInt(),ui->lineEdit_net_size->text().toInt());

QObject::connect(client, SIGNAL(signal_Set_value_speed(QString)), this , SLOT(slot_Set_value_speed(QString)));
QObject::connect(client, SIGNAL(signal_Set_value_maxmid(QString,QString)), this , SLOT(slot_Set_value_maxmid(QString,QString)));
 client->show();
 QEventLoop loop;

client->StartNetTest();
  loop.exec();
  //loop.exit(1);
}

void MainWindow::slot_Set_value_speed(QString speed)
{
    ui->tableWidget_NET->item(1,0)->setText(speed);

}
void MainWindow::slot_Set_value_maxmid(QString max, QString mid)
{
    ui->tableWidget_NET->item(3,0)->setText(max);
    ui->tableWidget_NET->item(2,0)->setText(mid);
    QIcon qicon;
    qicon.addFile(":/res/res/Ethernet-Cable-icon-OK.png");
    ui->tabWidget->setTabIcon(2,qicon);
}

//*****************    HDD  **************************
// запуск HDD
void MainWindow::StartTestHDD()
{

    QString hdd_total(enviropments::getHDD_Total());
    if (hdd_total.length()>1)
            {
            ui->tableWidget_HDD->item(1,0)->setText(hdd_total);
            }

    QString hdd_free(enviropments::getHDD_Free());
    if (hdd_free.length()>1)
            {
            ui->tableWidget_HDD->item(2,0)->setText(hdd_free);
            }



 HDTest *hdwid = new HDTest();

hdwid->init_form(
        ui->lineEdit_hdd_l_count->text().toInt(),
        ui->lineEdit_hdd_b_count->text().toInt(),
        ui->lineEdit_hdd_l_size->text().toInt(),
        ui->lineEdit_hdd_b_size->text().toInt()
        );

QObject::connect(hdwid, SIGNAL(signal_Set_value_HDD(QString,QString,QString,QString,QString,QString)), this , SLOT(slot_Set_value_HDD(QString,QString,QString,QString,QString,QString)));
 hdwid->show();
hdwid->startTest();
QIcon qicon;
qicon.addFile(":/res/res/hard-drive_OK.png");
ui->tabWidget->setTabIcon(4,qicon);

}

void MainWindow::slot_Set_value_HDD(QString wl, QString wb, QString rl, QString rb, QString rwl, QString rwb)
{
    ui->tableWidget_HDD->item(3,0)->setText(wl);
    ui->tableWidget_HDD->item(4,0)->setText(wb);
    ui->tableWidget_HDD->item(5,0)->setText(rl);
    ui->tableWidget_HDD->item(6,0)->setText(rb);
    ui->tableWidget_HDD->item(7,0)->setText(rwl);
    ui->tableWidget_HDD->item(8,0)->setText(rwb);
}


QDomElement makeElement(      QDomDocument& domDoc,
                        const QString&      strName,
                        const QString&      strAttr = QString::null,
                        const QString&      strText = QString::null
                       )
{
    QDomElement domElement = domDoc.createElement(strName);

    if (!strAttr.isEmpty()) {
        QDomAttr domAttr = domDoc.createAttribute("number");
        domAttr.setValue(strAttr);
        domElement.setAttributeNode(domAttr);
    }

    if (!strText.isEmpty()) {
        QDomText domText = domDoc.createTextNode(strText);
        domElement.appendChild(domText);
    }
    return domElement;
}

// ----------------------------------------------------------------------
QDomElement info(      QDomDocument& domDoc,
                    const QString&      strDate,
                    const QString&      strTime,
                    const QString&      strOS,
                    const QString&      vtname,
                    const QString&      vtnumber,
                    const QString&      manufacturer,
                    const QString&      osname,
                    const QString&      osversion ,
                    const QString&      fio,
                    const QString&      post,
                    const QString&      organization

                   )
{
    static int nNumber = 1;

    QDomElement domElement = makeElement(domDoc,
                                         "info"
                   //                      QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "date", "", strDate));
    domElement.appendChild(makeElement(domDoc, "time", "", strTime));
    domElement.appendChild(makeElement(domDoc, "OSreal", "", strOS));
    domElement.appendChild(makeElement(domDoc, "vtname", "", vtname));
    domElement.appendChild(makeElement(domDoc, "vtnumber", "", vtnumber));
    domElement.appendChild(makeElement(domDoc, "manufacturer", "", manufacturer));
    domElement.appendChild(makeElement(domDoc, "osname", "", osname));
    domElement.appendChild(makeElement(domDoc, "osversion", "", osversion));
    domElement.appendChild(makeElement(domDoc, "fio", "", fio));
    domElement.appendChild(makeElement(domDoc, "post", "", post));
    domElement.appendChild(makeElement(domDoc, "organization", "", organization));


    nNumber++;

    return domElement;
}
QDomElement elCPU(      QDomDocument& domDoc,
                    const QString&      strName,
                    const QString&      strMHz,
                    const QString&      strNProc
                   )
{
    //static int nNumber = 1;

    QDomElement domElement = makeElement(domDoc,
                                         "CPU"
                          //               QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "proc_name", "", strName));
    domElement.appendChild(makeElement(domDoc, "proc_MHz", "", strMHz));
    domElement.appendChild(makeElement(domDoc, "proc_N", "", strNProc));

    //nNumber++;

    return domElement;
}
QDomElement elVGA(      QDomDocument& domDoc,
                    const QString&      strName,
                    const QString&      strisOpenGL,
                    const QString&      strV,
                    const QString&      strFpsinterface,
                    const QString&      strFps2d,
                    const QString&      strFps3d,
                    const QString&      strFps3d_es
                   )
{
    //static int nNumber = 1;

    QDomElement domElement = makeElement(domDoc,
                                         "vga"
                          //               QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "vga_name", "", strName));
    domElement.appendChild(makeElement(domDoc, "vga_isopengl", "", strisOpenGL));
    domElement.appendChild(makeElement(domDoc, "vga_V", "", strV));
    domElement.appendChild(makeElement(domDoc, "vga_fpsinterface", "", strFpsinterface));
    domElement.appendChild(makeElement(domDoc, "vga_fps2d", "", strFps2d));
    domElement.appendChild(makeElement(domDoc, "vga_fps3d", "", strFps3d));
    domElement.appendChild(makeElement(domDoc, "vga_fps3d_es", "", strFps3d_es));
    //nNumber++;

    return domElement;
}

QDomElement elRAM(      QDomDocument& domDoc,
                    const QString&      ram_type,
                    const QString&      ram_total,
                    const QString&      ram_free,
                    const QString&      ram_stat_w,
                    const QString&      ram_stat_r,
                    const QString&      ram_stat_rw,
                    const QString&      ram_din_w,
                    const QString&      ram_din_r,
                    const QString&      ram_din_rw
                   )
{
    //static int nNumber = 1;

    QDomElement domElement = makeElement(domDoc,
                                         "ram"
                          //               QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "ram_type", "", ram_type));
    domElement.appendChild(makeElement(domDoc, "ram_total", "", ram_total));
    domElement.appendChild(makeElement(domDoc, "ram_free", "", ram_free));
    domElement.appendChild(makeElement(domDoc, "ram_stat_w", "", ram_stat_w));
    domElement.appendChild(makeElement(domDoc, "ram_stat_r", "", ram_stat_r));
    domElement.appendChild(makeElement(domDoc, "ram_stat_rw", "", ram_stat_rw));
    domElement.appendChild(makeElement(domDoc, "ram_din_w", "", ram_din_w));
    domElement.appendChild(makeElement(domDoc, "ram_din_r", "", ram_din_r));
    domElement.appendChild(makeElement(domDoc, "ram_din_rw", "", ram_din_rw));
    //nNumber++;

    return domElement;
}


QDomElement elHDD(      QDomDocument& domDoc,
                    const QString&      hdd_type,
                    const QString&      hdd_total,
                    const QString&      hdd_free,
                    const QString&      hdd_litle_w,
                    const QString&      hdd_big_w,
                    const QString&      ram_litle_r,
                    const QString&      ram_big_r,
                    const QString&      ram_litle_rw,
                    const QString&      ram_big_rw
                   )
{
    //static int nNumber = 1;

    QDomElement domElement = makeElement(domDoc,
                                         "hdd"
                          //               QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "hdd_type", "", hdd_type));
    domElement.appendChild(makeElement(domDoc, "hdd_total", "", hdd_total));
    domElement.appendChild(makeElement(domDoc, "hdd_free", "", hdd_free));
    domElement.appendChild(makeElement(domDoc, "hdd_litle_w", "", hdd_litle_w));
    domElement.appendChild(makeElement(domDoc, "hdd_big_w", "", hdd_big_w));
    domElement.appendChild(makeElement(domDoc, "ram_litle_r", "", ram_litle_r));
    domElement.appendChild(makeElement(domDoc, "ram_big_r", "", ram_big_r));
    domElement.appendChild(makeElement(domDoc, "ram_litle_rw", "", ram_litle_rw));
    domElement.appendChild(makeElement(domDoc, "ram_big_rw", "", ram_big_rw));
    //nNumber++;

    return domElement;
}
QDomElement elNet(      QDomDocument& domDoc,
                    const QString&      count_ports,
                    const QString&      speed,
                    const QString&      max_msec,
                    const QString&      mid_msec
                                     )
{
    //static int nNumber = 1;

    QDomElement domElement = makeElement(domDoc,
                                         "net"
                          //               QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "count_ports", "", count_ports));
    domElement.appendChild(makeElement(domDoc, "speed", "", speed));
    domElement.appendChild(makeElement(domDoc, "max_msec", "", max_msec));
    domElement.appendChild(makeElement(domDoc, "mid_msec", "", mid_msec));

    //nNumber++;

    return domElement;
}
void MainWindow::SaveResult()
{
    QDomDocument doc("banchmark");
    QDomElement  domElementall = doc.createElement("alltests");
    doc.appendChild(domElementall);
    QDomElement  domElement = doc.createElement("test");
 //   domElement.setAttribute("id",id_test);  Если нужен будет id
    domElement.setAttribute("id", QDateTime::currentDateTime().toString("yyMMddhhmmss"));
    // (yyMMddhhmmss););

    domElementall.appendChild(domElement);

    QDomElement info1 =
        info(doc,
             QDate::currentDate().toString("dd/MM/yyyy"),
             QTime::currentTime().toString(),
             MainWindow::osVersion(),
             m_settings.value("/Settings/vtname", "").toString(),
             m_settings.value("/Settings/vtnumber", "").toString(),
             m_settings.value("/Settings/manufacturer", "").toString(),
             m_settings.value("/Settings/osname", "").toString(),
             m_settings.value("/Settings/osversion", "").toString(),
             m_settings.value("/Settings/fio", "").toString(),
             m_settings.value("/Settings/post", "").toString(),
             m_settings.value("/Settings/organization", "").toString()
             );

    QDomElement cpu =
            elCPU(doc,
                  ui->tableWidget_CPU->item(0,0)->text(),
                  ui->tableWidget_CPU->item(1,0)->text(),
                  ui->tableWidget_CPU->item(2,0)->text()
                 );


   QDomElement vga = elVGA(doc,
                         ui->tableWidget_VGA->item(0,0)->text(),
                         ui->tableWidget_VGA->item(1,0)->text(),
                         ui->tableWidget_VGA->item(2,0)->text(),
                         ui->tableWidget_VGA->item(3,0)->text(),
                         ui->tableWidget_VGA->item(4,0)->text(),
                         ui->tableWidget_VGA->item(5,0)->text(),
                         ui->tableWidget_VGA->item(6,0)->text()
                         );

   QDomElement ram = elRAM(doc,
                         ui->tableWidget_RAM->item(0,0)->text(),
                         ui->tableWidget_RAM->item(1,0)->text(),
                         ui->tableWidget_RAM->item(2,0)->text(),
                         ui->tableWidget_RAM->item(3,0)->text(),
                         ui->tableWidget_RAM->item(4,0)->text(),
                         ui->tableWidget_RAM->item(5,0)->text(),
                         ui->tableWidget_RAM->item(6,0)->text(),
                         ui->tableWidget_RAM->item(7,0)->text(),
                         ui->tableWidget_RAM->item(8,0)->text()
                         );
   QDomElement hdd = elHDD(doc,
                         ui->tableWidget_HDD->item(0,0)->text(),
                         ui->tableWidget_HDD->item(1,0)->text(),
                         ui->tableWidget_HDD->item(2,0)->text(),
                         ui->tableWidget_HDD->item(3,0)->text(),
                         ui->tableWidget_HDD->item(4,0)->text(),
                         ui->tableWidget_HDD->item(5,0)->text(),
                         ui->tableWidget_HDD->item(6,0)->text(),
                         ui->tableWidget_HDD->item(7,0)->text(),
                         ui->tableWidget_HDD->item(8,0)->text()
                         );
   QDomElement net = elNet(doc,
                         ui->tableWidget_NET->item(0,0)->text(),
                         ui->tableWidget_NET->item(1,0)->text(),
                         ui->tableWidget_NET->item(2,0)->text(),
                         ui->tableWidget_NET->item(3,0)->text()
                           );
    domElement.appendChild(info1);
    domElement.appendChild(cpu);
    domElement.appendChild(vga);
    domElement.appendChild(ram);
    domElement.appendChild(hdd);
    domElement.appendChild(net);
/*    QFile file("testALL.xml");
    if(file.open(QIODevice::WriteOnly)) {//Append

      QString str = doc.toString(3);
    // str.replace("<!DOCTYPE banchmark>","");
    // str.replace("<alltests>","");
      QTextStream(&file) << str;
      file.close();
*/
   QDomDocument domDoc;
   QFile        file("testALL.xml");

      if(file.open(QIODevice::ReadOnly)) {
          if(domDoc.setContent(&file)) {
              QDomElement domElement1= domDoc.documentElement();
              domElement1.insertBefore(domElementall.firstChild(),domElement1.firstChild());
          }
         file.close();
         if(file.open(QIODevice::WriteOnly))  {
             QTextStream(&file) << domDoc.toString(3);
         }

          file.close();





    }
  }
//}


    void MainWindow::traverseNode(const QDomNode& node)
    {
       QDomNode domNode = node.firstChild();

       while(!domNode.isNull()) {
           if(domNode.isElement()) {

              QDomElement domElement = domNode.toElement();


              if(!domElement.isNull()) {
           //    if(domElement.tagName() == "test") {

                   // traverseNode_etalon(domNode.nextSibling());

               //    qDebug() << "Attr: "
                //           << domElement.attribute("id", "");
                   //   domElement.childNodes()

               //  }
               //  else {
                  //   qDebug() << "TagName: " << domElement.tagName()
                   //            << "\tText: " << domElement.text();
//domElement.parentNode().nodeName()== "etalon"
                 //    if (domElement.parentNode().parentNode().nodeName()== "etalon")
                  //   {
                  //   qDebug() << "etalonTagName: " << domElement.tagName();

                   //  }
        if (domElement.parentNode().parentNode().nodeName()== "etalon")
                     {  if (domElement.tagName() == "proc_name")
                      {
                       ui->tableWidget_CPU->item(0,1)->setText(domElement.text());
                //       qDebug() << "etalonTagName: " << domElement.tagName() << " Text: " << domElement.text();
                      }
                     if (domElement.tagName() == "proc_MHz")
                      { ui->tableWidget_CPU->item(1,1)->setText(domElement.text());
                   //    qDebug() << "etalonTagName: " << domElement.tagName() << " Text: " << domElement.text();
                      }
                   if (domElement.tagName() == "proc_N")
                        { ui->tableWidget_CPU->item(2,1)->setText(domElement.text());
                      }
                      if(domElement.tagName() == "vga_name")
                        {
                       ui->tableWidget_VGA->item(0,1)->setText(domElement.text());
                      }
                      if (domElement.tagName() == "vga_isopengl")
                        {
                       ui->tableWidget_VGA->item(1,1)->setText(domElement.text());
                      }

                      if (domElement.tagName() == "vga_V")
                        {
                       ui->tableWidget_VGA->item(2,1)->setText(domElement.text());
                      }
                      if  (domElement.tagName() == "vga_fpsinterface")
                      {
                       ui->tableWidget_VGA->item(3,1)->setText(domElement.text());
                      }
                      if (domElement.tagName() == "vga_fps2d")
                        {
                       ui->tableWidget_VGA->item(4,1)->setText(domElement.text());
                      }
                      if (domElement.tagName() == "vga_fps3d")
                        {
                       ui->tableWidget_VGA->item(5,1)->setText(domElement.text());
                      }
                      if (domElement.tagName() == "vga_fps3d_es")
                        {
                       ui->tableWidget_VGA->item(6,1)->setText(domElement.text());
                      }

                      if (domElement.tagName() == "ram_type")
                        {  ui->tableWidget_RAM->item(0,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_total")
                        {  ui->tableWidget_RAM->item(1,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_free")
                        {  ui->tableWidget_RAM->item(2,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_stat_w")
                        {  ui->tableWidget_RAM->item(3,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_stat_r")
                        {  ui->tableWidget_RAM->item(4,1)->setText(domElement.text()); }
                      if  (domElement.tagName() == "ram_stat_rw")
                        {  ui->tableWidget_RAM->item(5,1)->setText(domElement.text()); }
                      if  (domElement.tagName() == "ram_din_w")
                        {  ui->tableWidget_RAM->item(6,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_din_r")
                        {  ui->tableWidget_RAM->item(7,1)->setText(domElement.text()); }
                      if  (domElement.tagName() == "ram_din_rw")
                        {  ui->tableWidget_RAM->item(8,1)->setText(domElement.text()); }

                      if (domElement.tagName() == "hdd_type")
                        {  ui->tableWidget_HDD->item(0,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "hdd_total")
                        {  ui->tableWidget_HDD->item(1,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_free")
                        {  ui->tableWidget_HDD->item(2,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "hdd_litle_w")
                        {  ui->tableWidget_HDD->item(3,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "hdd_big_w")
                        {  ui->tableWidget_HDD->item(4,1)->setText(domElement.text()); }
                      if  (domElement.tagName() == "ram_litle_r")
                        {  ui->tableWidget_HDD->item(5,1)->setText(domElement.text()); }
                      if  (domElement.tagName() == "ram_big_r")
                        {  ui->tableWidget_HDD->item(6,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "ram_litle_rw")
                        {  ui->tableWidget_HDD->item(7,1)->setText(domElement.text()); }
                      if  (domElement.tagName() == "ram_big_rw")
                        {  ui->tableWidget_HDD->item(8,1)->setText(domElement.text()); }

                      if (domElement.tagName() == "count_ports")
                        {  ui->tableWidget_NET->item(0,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "speed")
                        {  ui->tableWidget_NET->item(1,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "max_msec")
                        {  ui->tableWidget_NET->item(2,1)->setText(domElement.text()); }
                      if (domElement.tagName() == "mid_msec")
                        {  ui->tableWidget_NET->item(3,1)->setText(domElement.text()); }
                 }
              }
           }
           traverseNode(domNode);
           domNode = domNode.nextSibling();
        }
}

void MainWindow::ReadResult()
{
    QDomDocument domDoc;
    QFile        file("testALL.xml");

    if(file.open(QIODevice::ReadOnly)) {
        if(domDoc.setContent(&file)) {
            QDomElement domElement= domDoc.documentElement();
            traverseNode(domElement);
        }
        file.close();
    }
}

void MainWindow::traverseNode_init(const QDomNode& node)
{
   QDomNode domNode = node.firstChild();

   while(!domNode.isNull()) {
       if(domNode.isElement()) {

          QDomElement domElement = domNode.toElement();
        //  qDebug() << "t: "; //<< domNode.toText();

          if(!domElement.isNull()) {
             // if(domElement.tagName() == "test") {
               //  qDebug() << "Attr: "
               //          << domElement.attribute("id", "");
               //   domElement.childNodes()

              //}
              //else {
              //    qDebug() << "TagName: " << domElement.tagName()
               //            << "\tText: " << domElement.text();

               //  qDebug() << "TagName: " << domElement.tagName()
                // << "\tText: " << domElement.text();
                  if(domElement.tagName() == "id"){
                      id_test =domElement.text().toInt();

                  }
                  if(domElement.tagName() == "frameinterface"){
                   ui->lineEdit_interface->setText(domElement.text());
                  }
                  if(domElement.tagName() == "frame2d"){
                   ui->lineEdit_2dmap->setText(domElement.text());
                  }
                  if(domElement.tagName() == "frame3d"){
                   ui->lineEdit_3d->setText(domElement.text());
                  }
                  if(domElement.tagName() == "ram_size"){
                   ui->lineEdit_ram_size->setText(domElement.text());
                  }
                  if(domElement.tagName() == "ram_count"){
                   ui->lineEdit_ram_count->setText(domElement.text());
                  }
                  if(domElement.tagName() == "hdd_l_size"){
                   ui->lineEdit_hdd_l_size->setText(domElement.text());
                  }
                   if(domElement.tagName() == "hdd_l_count"){
                   ui->lineEdit_hdd_l_count->setText(domElement.text());
                  }
                   if(domElement.tagName() == "hdd_b_size"){
                    ui->lineEdit_hdd_b_size->setText(domElement.text());
                   }
                    if(domElement.tagName() == "hdd_b_count"){
                    ui->lineEdit_hdd_b_count->setText(domElement.text());
                   }
                    if(domElement.tagName() == "net_size"){
                    ui->lineEdit_net_size->setText(domElement.text());
                   }

                    if(domElement.tagName() == "net_count"){
                    ui->lineEdit_net_count->setText(domElement.text());
                   }

                    if(domElement.tagName() == "net_ip"){
                    ui->lineEdit_net_ip->setText(domElement.text());
                   }
                    if(domElement.tagName() == "net_port"){
                    ui->lineEdit_net_port->setText(domElement.text());
                   }


             }
         // }
       }
       traverseNode_init(domNode);
       domNode = domNode.nextSibling();

}
}
void MainWindow::Readinit()
{
    QDomDocument domDoc1;
    QFile        file("initbamchmark.xml");

    if(file.open(QIODevice::ReadOnly)) {
        if(domDoc1.setContent(&file)) {
            QDomElement domElement= domDoc1.documentElement();
            traverseNode_init(domElement);
        }
        file.close();
    }
}

QDomElement init(      QDomDocument& domDoc,
                    const QString&      id,
                    const QString&      frameinterface,
                    const QString&      frame2d,
                    const QString&      frame3d,
                    const QString&      ram_size,
                    const QString&      ram_count,
                    const QString&      hdd_l_size,
                    const QString&      hdd_l_count,
                    const QString&      hdd_b_size,
                    const QString&      hdd_b_count,
                    const QString&      net_count,
                    const QString&      net_size,
                    const QString&      net_ip,
                    const QString&      net_port
                    )
{


    QDomElement domElement = makeElement(domDoc,
                                         "init"
                   //                      QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "id", "", id));
    domElement.appendChild(makeElement(domDoc, "frameinterface", "", frameinterface));
    domElement.appendChild(makeElement(domDoc, "frame2d", "", frame2d));
    domElement.appendChild(makeElement(domDoc, "frame3d", "", frame3d));
    domElement.appendChild(makeElement(domDoc, "ram_size", "", ram_size));
    domElement.appendChild(makeElement(domDoc, "ram_count", "", ram_count));
    domElement.appendChild(makeElement(domDoc, "hdd_l_size", "", hdd_l_size));
    domElement.appendChild(makeElement(domDoc, "hdd_l_count", "", hdd_l_count));
    domElement.appendChild(makeElement(domDoc, "hdd_b_size", "", hdd_b_size));
    domElement.appendChild(makeElement(domDoc, "hdd_b_count", "", hdd_b_count));
    domElement.appendChild(makeElement(domDoc, "net_count", "", net_count));

      domElement.appendChild(makeElement(domDoc, "net_size", "", net_size));
    domElement.appendChild(makeElement(domDoc, "net_ip", "", net_ip));
    domElement.appendChild(makeElement(domDoc, "net_port", "", net_port));

    return domElement;
}
QDomElement reg(      QDomDocument& domDoc,
                    const QString&      vtname,
                    const QString&      vtnumber,
                    const QString&      manufacturer,
                    const QString&      osname,
                    const QString&      osversion,
                    const QString&      fio,
                    const QString&      post,
                    const QString&      organization

                  )
{


    QDomElement domElement = makeElement(domDoc,
                                         "reg"
                   //                      QString().setNum(nNumber)
                                        );
    domElement.appendChild(makeElement(domDoc, "vtname", "", vtname));
    domElement.appendChild(makeElement(domDoc, "vtnumber", "", vtnumber));
    domElement.appendChild(makeElement(domDoc, "manufacturer", "", manufacturer));
    domElement.appendChild(makeElement(domDoc, "osname", "", osname));
    domElement.appendChild(makeElement(domDoc, "osversion", "", osversion));
    domElement.appendChild(makeElement(domDoc, "fio", "", fio));
    domElement.appendChild(makeElement(domDoc, "post", "", post));
    domElement.appendChild(makeElement(domDoc, "organization", "", organization));


    return domElement;
}
void MainWindow::Saveinit()
{
    QDomDocument doc("banchmark");
    QDomElement  domElement = doc.createElement("test");
    doc.appendChild(domElement);

 QString str;
 str.setNum(id_test); // id из файла настроек


    QDomElement init1 =
        init(doc,
                 str ,
                 ui->lineEdit_interface->text(),
                 ui->lineEdit_2dmap->text(),
                 ui->lineEdit_3d->text(),
                 ui->lineEdit_ram_size->text(),
                 ui->lineEdit_ram_count->text(),
                 ui->lineEdit_hdd_l_size->text(),
                 ui->lineEdit_hdd_l_count->text(),
                 ui->lineEdit_hdd_b_size->text(),
                 ui->lineEdit_hdd_b_count->text(),
                 ui->lineEdit_net_count->text(),
                 ui->lineEdit_net_size->text(),
                 ui->lineEdit_net_ip->text(),
                 ui->lineEdit_net_port->text()
                  );

    QDomElement reg1 =
        reg(doc,
             m_settings.value("/Settings/vtname", "").toString(),
             m_settings.value("/Settings/vtnumber", "").toString(),
             m_settings.value("/Settings/manufacturer", "").toString(),
             m_settings.value("/Settings/osname", "").toString(),
             m_settings.value("/Settings/osversion", "").toString(),
             m_settings.value("/Settings/fio", "").toString(),
             m_settings.value("/Settings/post", "").toString(),
             m_settings.value("/Settings/organization", "").toString()
             );




    domElement.appendChild(init1);
    domElement.appendChild(reg1);
    QFile file("initbamchmark.xml");
    if(file.open(QIODevice::WriteOnly)) {//Append

      QString str = doc.toString(3);
    // str.replace("<!DOCTYPE banchmark>","");
    // str.replace("<alltests>","");
      QTextStream(&file) << str;
      file.close();

  /* QDomDocument domDoc;
      QFile        file("testALL.xml");

      if(file.open(QIODevice::ReadOnly)) {
          if(domDoc.setContent(&file)) {
              QDomElement domElement1= domDoc.documentElement();
              domElement1.insertBefore(domElementall.firstChild(),domElement1.firstChild());
          }
         file.close();
         if(file.open(QIODevice::WriteOnly))  {
             QTextStream(&file) << domDoc.toString(3);
         }
         // doc.toString(3);
          file.close();

*/



    }
  }



